               JOB  Function 118 -- Sin and Cosine
               CTL  6611
     *
     x1        equ  89
     x2        equ  94
     x3        equ  99
     *
     * Addresses in ARITF
     *
     savop     equ  924   Arithmetic routine op code
     nmlz2     equ  1024  Normalize floating-point result
     zas       equ  1087  Set sign of result
     clrwk     equ  1134  Clear accum1
     strze     equ  1142  Exponent underflow
     ermsg     equ  1471  Print error message
     exp2      equ  1680  Exponent of accum 2, and zero and RM
     exp1      equ  1683  Exponent of accum 1, and zero
     *
     * Addresses in series routine
     *
     argred    equ  14000  argument reduction
     series    equ  14047  series evaluation
     setone    equ  14191  Set result to 1.0
     B         equ  14250
     DI        equ  14256
     D0        equ  14259
     C0        equ  14253
     *
               ORG  2000
 2000sincos    BCE  cos1,savop,C  Cosine?
 2008          BE   strze  Exponent underflow
 2013          MZ   279&X3,setzas  result has same sign as arg
 2020          B    sin1
 2024cos1      BE   setone
 2029          MZ   kp1,setzas  result has positive sign
 2036sin1      MCW  kb1,w1
 2043          ZA   exp2-1,exp1-1
 2050          S    kp1,exp2-1
 2057          BM   negexp,exp2-1
 2065          A    kp2,exp2-1
 2072          S    x3,exp2-1
 2079          BWZ  scale,exp2-1,B
 2087          ZA   exp1-1,exp2-1
 2094          SBR  x1,pid2&X3  PI/2 with correct number of digits
 2101          ZA   exp2,x2&1
 2108          B    argred      argument reduction
 2112          ZA   1&X1,x2&1
 2119          S    kp40,x2&1   why not sbr x2,15996&x2 ???
 2126          BWZ  *-14,x2&1,B
 2134          BCE  cos2,savop,C  Cosine?
 2142          SBR  x2,1&X2
 2149cos2      MZ   akjba-5&X2,zas
 2156          MN   akjba-5&X2,w1
 2163          S    D0
 2167          S    exp2-1
 2171          BCE  cos3,w1,2
 2179sin3      ZA   279&X3,202&X3
 2186          B    hset        set H(x)
 2190          ZA   202&X3,249
 2197          ZA   251
 2201          ZS   kp2,c0
 2208eval      ZA   kp8,B
 2215          S    DI
 2219          B    series      series evaluation
 2223setzas    ZA   zas
 2227          SBR  x2,201&X3
 2234          B    nmlz2
 2238cos3      B    hset        set H(x)
 2242          MN   kp1,0&X1
 2249          ZS   kp6,c0
 2256          S    exp2-1
 2260          B    eval
     *
     * Set H(x) = -x**2
     *
 2264hset      SBR  hsetx&3
 2268          MCW  279&X3,250
 2275          SBR  x1
 2279          LCA  k0
 2283          M    279&X3,251&X3
 2290          ZS   252,279&X3
 2297          S    251
 2301hsetx     B    0
     *
 2305negexp    A    x3,exp2-1
 2312          BM   undflo,exp2-1
 2320          ZA   exp1-1,exp2-1
 2327          MZ   279&X3,278&X3
 2334          ZA   278&X3,279&X3
 2341          A    exp1-1
 2345          ZS   exp1,D0
 2352          MZ   kp1,zas
 2359          BCE  cos3,savop,C  Cosine?
 2367          B    sin3
     *
     * Underflow
     *
 2371undflo    BCE  setone,savop,C  Cosine?
 2379          ZA   exp1-1,exp2-1
 2386          B    clrwk
     *
     * Argument of sine or cosine too large
     *
 2390scale     B    ermsg
 2396          DCW  @SCL@
 2397          B    strze  Exponent underflow
     *
 2405akjba     DCW  @AKJBA@
     pid2      equ  *
 2427          DCW  @1570796326794896619231@
 2428kp1       dcw  &1
 2429kb1       DCW  #1
 2430kp2       dcw  &2
 2432kp40      DCW  &40  
 2433w1        DCW  #1
 2434kp8       dcw  &8
 2435kp6       DCW  &6
 2436k0        DCW  0
               end
